/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V2_TEST_AUDIO_CONTROLLER_SOMEIP_STUB_ADAPTER_HPP_
#define V2_TEST_AUDIO_CONTROLLER_SOMEIP_STUB_ADAPTER_HPP_

#include <v2/Test/Audio/ControllerStub.hpp>
#include <v2/Test/Audio/ControllerSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>
#include <CommonAPI/SomeIP/StubAdapterHelper.hpp>
#include <CommonAPI/SomeIP/StubAdapter.hpp>
#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Constants.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v2 {
namespace Test {
namespace Audio {

template <typename _Stub = ::v2::Test::Audio::ControllerStub, typename... _Stubs>
class ControllerSomeIPStubAdapterInternal
    : public virtual ControllerStubAdapter,
      public CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...>,
      public std::enable_shared_from_this< ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>>
{
public:
    typedef CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...> ControllerSomeIPStubAdapterHelper;

    ~ControllerSomeIPStubAdapterInternal() {
        deactivateManagedInstances();
        ControllerSomeIPStubAdapterHelper::deinit();
    }

    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    void fireIVIDeviceInfoAttributeChanged(const ::v2::Test::Audio::Controller::KeyValueString &_value);
    
    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    void fireAudioSourceTypesAttributeChanged(const std::vector< std::string > &_value);
    
    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    void fireVolumeInfoAttributeChanged(const ::v2::Test::Audio::Controller::VolumeInfo &_value);
    
    void fireKeyValueByteBufferMapAttributeChanged(const ::v2::Test::Audio::Controller::KeyValueByteBuffer &_value);
    
    void fireDeviceStateMapAttributeChanged(const ::v2::Test::Audio::Controller::DeviceStateMap &_value);
    
    void fireStringToShortMapAttributeChanged(const ::v2::Test::Audio::Controller::StringToShortMap &_value);
    
    /*
     * description: 
     * broadcast when audio source type changed
     */
    void fireFocusStatusChangedEvent(const std::vector< ::v2::Test::Audio::Controller::FocusStatus > &_focusStatus);

    void deactivateManagedInstances() {}
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        CommonAPI::Version
    > getControllerInterfaceVersionStubDispatcher;

    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        ::v2::Test::Audio::Controller::KeyValueString,
        ::v2::Test::Audio::Controller_::KeyValueStringDeployment_t
    > getIVIDeviceInfoAttributeStubDispatcher;
    
    CommonAPI::SomeIP::SetObservableAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        ::v2::Test::Audio::Controller::KeyValueString,
        ::v2::Test::Audio::Controller_::KeyValueStringDeployment_t
    > setIVIDeviceInfoAttributeStubDispatcher;
    
    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        std::vector< std::string >,
        CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::StringDeployment >
    > getAudioSourceTypesAttributeStubDispatcher;
    
    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        ::v2::Test::Audio::Controller::VolumeInfo,
        ::v2::Test::Audio::Controller_::VolumeInfoDeployment_t
    > getVolumeInfoAttributeStubDispatcher;
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        ::v2::Test::Audio::Controller::KeyValueByteBuffer,
        ::v2::Test::Audio::Controller_::KeyValueByteBufferDeployment_t
    > getKeyValueByteBufferMapAttributeStubDispatcher;
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        ::v2::Test::Audio::Controller::DeviceStateMap,
        ::v2::Test::Audio::Controller_::DeviceStateMapDeployment_t
    > getDeviceStateMapAttributeStubDispatcher;
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        ::v2::Test::Audio::Controller::StringToShortMap,
        ::v2::Test::Audio::Controller_::StringToShortMapDeployment_t
    > getStringToShortMapAttributeStubDispatcher;
    
    /*
     * description: 
     * The ccRC system requests to obtain audio focus.
     */
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        std::tuple< std::string, Controller::AudioDeviceType>,
        std::tuple< Controller::FocusControlError, Controller::AudioFocusResultType>,
        std::tuple< CommonAPI::SomeIP::StringDeployment, ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t>,
        std::tuple< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t, ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t>
    > obtainFocusStubDispatcher;
    
    /*
     * description: 
     * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
     */
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        std::tuple< std::string, Controller::AudioDeviceType>,
        std::tuple< Controller::FocusControlError>,
        std::tuple< CommonAPI::SomeIP::StringDeployment, ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t>,
        std::tuple< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t>
    > releaseFocusStubDispatcher;
    
    /*
     * description: 
     * Set the volume for outside the system.
     */
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        std::tuple< uint8_t>,
        std::tuple< Controller::VolumeControlError>,
        std::tuple< CommonAPI::SomeIP::IntegerDeployment<uint8_t>>,
        std::tuple< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t>
    > setVolumeStubDispatcher;
    
    /*
     * description: 
     * request to set source volume.
     * There are two member field in the Input parameter.
     * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
     * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
     * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
     * 
     * - maxVolume : it defines volume limitation which is described from the requirement
     * - VolumeControlError : please see "setVolume" for more detail explanation
     */
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        std::tuple< std::string, uint16_t, uint32_t>,
        std::tuple< Controller::VolumeControlError>,
        std::tuple< CommonAPI::SomeIP::StringDeployment, CommonAPI::SomeIP::IntegerDeployment<uint16_t>, CommonAPI::SomeIP::IntegerDeployment<uint32_t>>,
        std::tuple< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t>
    > setSourceVolumeStubDispatcher;
    
    /*
     * description: 
     * Get FocusStatus and VolumeInfo for audio source type
     */
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v2::Test::Audio::ControllerStub,
        std::tuple< std::string>,
        std::tuple< Controller::ErrorType, Controller::AudioSourceStatusInfo>,
        std::tuple< CommonAPI::SomeIP::StringDeployment>,
        std::tuple< ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t, ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t>
    > getAudioSourceStatusStubDispatcher;
    
    ControllerSomeIPStubAdapterInternal(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub):
        CommonAPI::SomeIP::StubAdapter(_address, _connection),
        ControllerSomeIPStubAdapterHelper(
            _address,
            _connection,
            std::dynamic_pointer_cast< ControllerStub>(_stub)),
        getControllerInterfaceVersionStubDispatcher(&ControllerStub::lockInterfaceVersionAttribute, &ControllerStub::getInterfaceVersion, false, true),
        getIVIDeviceInfoAttributeStubDispatcher(
            &::v2::Test::Audio::ControllerStub::lockIVIDeviceInfoAttribute,
            &::v2::Test::Audio::ControllerStub::getIVIDeviceInfoAttribute,
            false,
            _stub->hasElement(0)),
        setIVIDeviceInfoAttributeStubDispatcher(
            &::v2::Test::Audio::ControllerStub::lockIVIDeviceInfoAttribute,
            &::v2::Test::Audio::ControllerStub::getIVIDeviceInfoAttribute,
            &ControllerStubRemoteEvent::onRemoteSetIVIDeviceInfoAttribute,
            &ControllerStubRemoteEvent::onRemoteIVIDeviceInfoAttributeChanged,
            &ControllerStubAdapter::fireIVIDeviceInfoAttributeChanged,
            false,
            _stub->hasElement(0))
        ,
        getAudioSourceTypesAttributeStubDispatcher(
            &::v2::Test::Audio::ControllerStub::lockAudioSourceTypesAttribute,
            &::v2::Test::Audio::ControllerStub::getAudioSourceTypesAttribute,
            false,
            _stub->hasElement(1))
        ,
        getVolumeInfoAttributeStubDispatcher(
            &::v2::Test::Audio::ControllerStub::lockVolumeInfoAttribute,
            &::v2::Test::Audio::ControllerStub::getVolumeInfoAttribute,
            false,
            _stub->hasElement(2))
        ,
        getKeyValueByteBufferMapAttributeStubDispatcher(
            &::v2::Test::Audio::ControllerStub::lockKeyValueByteBufferMapAttribute,
            &::v2::Test::Audio::ControllerStub::getKeyValueByteBufferMapAttribute,
            false,
            _stub->hasElement(3))
        ,
        getDeviceStateMapAttributeStubDispatcher(
            &::v2::Test::Audio::ControllerStub::lockDeviceStateMapAttribute,
            &::v2::Test::Audio::ControllerStub::getDeviceStateMapAttribute,
            false,
            _stub->hasElement(4))
        ,
        getStringToShortMapAttributeStubDispatcher(
            &::v2::Test::Audio::ControllerStub::lockStringToShortMapAttribute,
            &::v2::Test::Audio::ControllerStub::getStringToShortMapAttribute,
            false,
            _stub->hasElement(5))
        ,
        obtainFocusStubDispatcher(
            &ControllerStub::ObtainFocus,
            false,
            _stub->hasElement(6),
            std::make_tuple(static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr), static_cast< ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t* >(nullptr)),
            std::make_tuple(static_cast< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t * >(nullptr), static_cast< ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t* >(nullptr)))
        
        ,
        releaseFocusStubDispatcher(
            &ControllerStub::ReleaseFocus,
            false,
            _stub->hasElement(7),
            std::make_tuple(static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr), static_cast< ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t* >(nullptr)),
            std::make_tuple(static_cast< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t * >(nullptr)))
        
        ,
        setVolumeStubDispatcher(
            &ControllerStub::SetVolume,
            false,
            _stub->hasElement(8),
            std::make_tuple(static_cast< CommonAPI::SomeIP::IntegerDeployment<uint8_t>* >(nullptr)),
            std::make_tuple(static_cast< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t * >(nullptr)))
        
        ,
        setSourceVolumeStubDispatcher(
            &ControllerStub::SetSourceVolume,
            false,
            _stub->hasElement(9),
            std::make_tuple(static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint16_t>* >(nullptr), static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr)),
            std::make_tuple(static_cast< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t * >(nullptr)))
        
        ,
        getAudioSourceStatusStubDispatcher(
            &ControllerStub::GetAudioSourceStatus,
            false,
            _stub->hasElement(10),
            std::make_tuple(static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr)),
            std::make_tuple(static_cast< ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t * >(nullptr), static_cast< ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t* >(nullptr)))
        
    {
        /*
         * description: 
         * test-purposed attribute which is read-write and map data type
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x2001) }, &getIVIDeviceInfoAttributeStubDispatcher );
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x2000) }, &setIVIDeviceInfoAttributeStubDispatcher );
        /*
         * description: 
         * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
         * The list has the following format and is a string with upcase letters.
         * -"YOUTUBE_STREAMING"
         * -"TVING_STREAMING"
         * -"WATCHAR_STREAMING"
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x2002) }, &getAudioSourceTypesAttributeStubDispatcher );
        /*
         * description: 
         * Contains the Volume Information include min and max levels.
         * The range of these variables depends on each platform specification.
         * -Volume range is defined by audio specification.
         * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
         * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
         * -Mute notify the current mute status. (true : Mute / false : Unmute)
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x2003) }, &getVolumeInfoAttributeStubDispatcher );
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x2004) }, &getKeyValueByteBufferMapAttributeStubDispatcher );
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x2005) }, &getDeviceStateMapAttributeStubDispatcher );
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x2006) }, &getStringToShortMapAttributeStubDispatcher );
        /*
         * description: 
         * The ccRC system requests to obtain audio focus.
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x1001) }, &obtainFocusStubDispatcher );
        /*
         * description: 
         * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x1002) }, &releaseFocusStubDispatcher );
        /*
         * description: 
         * Set the volume for outside the system.
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x1004) }, &setVolumeStubDispatcher );
        /*
         * description: 
         * request to set source volume.
         * There are two member field in the Input parameter.
         * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
         * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
         * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
         * 
         * - maxVolume : it defines volume limitation which is described from the requirement
         * - VolumeControlError : please see "setVolume" for more detail explanation
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x1009) }, &setSourceVolumeStubDispatcher );
        /*
         * description: 
         * Get FocusStatus and VolumeInfo for audio source type
         */
        ControllerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x100a) }, &getAudioSourceStatusStubDispatcher );
        std::shared_ptr<CommonAPI::SomeIP::ClientId> itsClient = std::make_shared<CommonAPI::SomeIP::ClientId>(0xFFFF, 0xFFFFFFFF, 0xFFFFFFFF);

        // Provided events/fields
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x1001));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x9001), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        if (_stub->hasElement(0)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1001)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0xa001), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireIVIDeviceInfoAttributeChanged(std::dynamic_pointer_cast< ::v2::Test::Audio::ControllerStub>(_stub)->getIVIDeviceInfoAttribute(itsClient));
        }

        if (_stub->hasElement(1)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1001)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0xa002), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireAudioSourceTypesAttributeChanged(std::dynamic_pointer_cast< ::v2::Test::Audio::ControllerStub>(_stub)->getAudioSourceTypesAttribute(itsClient));
        }

        if (_stub->hasElement(2)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1001)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0xa003), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireVolumeInfoAttributeChanged(std::dynamic_pointer_cast< ::v2::Test::Audio::ControllerStub>(_stub)->getVolumeInfoAttribute(itsClient));
        }

        if (_stub->hasElement(3)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1001)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0xa004), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireKeyValueByteBufferMapAttributeChanged(std::dynamic_pointer_cast< ::v2::Test::Audio::ControllerStub>(_stub)->getKeyValueByteBufferMapAttribute(itsClient));
        }

        if (_stub->hasElement(4)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1001)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0xa005), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireDeviceStateMapAttributeChanged(std::dynamic_pointer_cast< ::v2::Test::Audio::ControllerStub>(_stub)->getDeviceStateMapAttribute(itsClient));
        }

        if (_stub->hasElement(5)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1001)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0xa006), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireStringToShortMapAttributeChanged(std::dynamic_pointer_cast< ::v2::Test::Audio::ControllerStub>(_stub)->getStringToShortMapAttribute(itsClient));
        }

    }

    // Register/Unregister event handlers for selective broadcasts
    void registerSelectiveEventHandlers();
    void unregisterSelectiveEventHandlers();

};

/*
 * description: 
 * test-purposed attribute which is read-write and map data type
 */
template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireIVIDeviceInfoAttributeChanged(const ::v2::Test::Audio::Controller::KeyValueString &_value) {
    CommonAPI::Deployable< ::v2::Test::Audio::Controller::KeyValueString, ::v2::Test::Audio::Controller_::KeyValueStringDeployment_t> deployedValue(_value, static_cast< ::v2::Test::Audio::Controller_::KeyValueStringDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                ::v2::Test::Audio::Controller::KeyValueString,
                ::v2::Test::Audio::Controller_::KeyValueStringDeployment_t
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0xa001),
        false,
        deployedValue
    );
}

/*
 * description: 
 * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
 * The list has the following format and is a string with upcase letters.
 * -"YOUTUBE_STREAMING"
 * -"TVING_STREAMING"
 * -"WATCHAR_STREAMING"
 */
template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireAudioSourceTypesAttributeChanged(const std::vector< std::string > &_value) {
    CommonAPI::Deployable< std::vector< std::string >, CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::StringDeployment >> deployedValue(_value, static_cast< CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::StringDeployment >* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::vector< std::string >,
                CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::StringDeployment >
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0xa002),
        false,
        deployedValue
    );
}

/*
 * description: 
 * Contains the Volume Information include min and max levels.
 * The range of these variables depends on each platform specification.
 * -Volume range is defined by audio specification.
 * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
 * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
 * -Mute notify the current mute status. (true : Mute / false : Unmute)
 */
template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireVolumeInfoAttributeChanged(const ::v2::Test::Audio::Controller::VolumeInfo &_value) {
    CommonAPI::Deployable< ::v2::Test::Audio::Controller::VolumeInfo, ::v2::Test::Audio::Controller_::VolumeInfoDeployment_t> deployedValue(_value, static_cast< ::v2::Test::Audio::Controller_::VolumeInfoDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                ::v2::Test::Audio::Controller::VolumeInfo,
                ::v2::Test::Audio::Controller_::VolumeInfoDeployment_t
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0xa003),
        false,
        deployedValue
    );
}

template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireKeyValueByteBufferMapAttributeChanged(const ::v2::Test::Audio::Controller::KeyValueByteBuffer &_value) {
    CommonAPI::Deployable< ::v2::Test::Audio::Controller::KeyValueByteBuffer, ::v2::Test::Audio::Controller_::KeyValueByteBufferDeployment_t> deployedValue(_value, static_cast< ::v2::Test::Audio::Controller_::KeyValueByteBufferDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                ::v2::Test::Audio::Controller::KeyValueByteBuffer,
                ::v2::Test::Audio::Controller_::KeyValueByteBufferDeployment_t
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0xa004),
        false,
        deployedValue
    );
}

template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireDeviceStateMapAttributeChanged(const ::v2::Test::Audio::Controller::DeviceStateMap &_value) {
    CommonAPI::Deployable< ::v2::Test::Audio::Controller::DeviceStateMap, ::v2::Test::Audio::Controller_::DeviceStateMapDeployment_t> deployedValue(_value, static_cast< ::v2::Test::Audio::Controller_::DeviceStateMapDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                ::v2::Test::Audio::Controller::DeviceStateMap,
                ::v2::Test::Audio::Controller_::DeviceStateMapDeployment_t
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0xa005),
        false,
        deployedValue
    );
}

template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireStringToShortMapAttributeChanged(const ::v2::Test::Audio::Controller::StringToShortMap &_value) {
    CommonAPI::Deployable< ::v2::Test::Audio::Controller::StringToShortMap, ::v2::Test::Audio::Controller_::StringToShortMapDeployment_t> deployedValue(_value, static_cast< ::v2::Test::Audio::Controller_::StringToShortMapDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                ::v2::Test::Audio::Controller::StringToShortMap,
                ::v2::Test::Audio::Controller_::StringToShortMapDeployment_t
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0xa006),
        false,
        deployedValue
    );
}

/*
 * description: 
 * broadcast when audio source type changed
 */
template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireFocusStatusChangedEvent(const std::vector< ::v2::Test::Audio::Controller::FocusStatus > &_focusStatus) {
    CommonAPI::Deployable< std::vector< Controller::FocusStatus >, CommonAPI::SomeIP::ArrayDeployment< ::v2::Test::Audio::Controller_::FocusStatusDeployment_t >> deployed_focusStatus(_focusStatus, static_cast< CommonAPI::SomeIP::ArrayDeployment< ::v2::Test::Audio::Controller_::FocusStatusDeployment_t >* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< std::vector< ::v2::Test::Audio::Controller::FocusStatus >, CommonAPI::SomeIP::ArrayDeployment< ::v2::Test::Audio::Controller_::FocusStatusDeployment_t > > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x9001),
            false,
             deployed_focusStatus 
    );
}


template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::registerSelectiveEventHandlers() {
}

template <typename _Stub, typename... _Stubs>
void ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>::unregisterSelectiveEventHandlers() {
}

template <typename _Stub = ::v2::Test::Audio::ControllerStub, typename... _Stubs>
class ControllerSomeIPStubAdapter
    : public ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...> {
public:
    ControllerSomeIPStubAdapter(const CommonAPI::SomeIP::Address &_address,
                                            const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
                                            const std::shared_ptr<CommonAPI::StubBase> &_stub)
        : CommonAPI::SomeIP::StubAdapter(_address, _connection),
          ControllerSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub) {
    }
};

} // namespace Audio
} // namespace Test
} // namespace v2

#endif // V2_TEST_AUDIO_Controller_SOMEIP_STUB_ADAPTER_HPP_
